import { __awaiter, __extends, __generator } from "tslib";
import dcopy from 'deep-copy';
import sanitizer from '../../_shared/utils/sanitizer';
import BaseCreatorApiConsumer from '../base-creator-api-consumer/base-creator-api-consumer';
var EndpointCreatorApiConsumer = /** @class */ (function (_super) {
    __extends(EndpointCreatorApiConsumer, _super);
    function EndpointCreatorApiConsumer(_a, params) {
        var baseUrl = _a.baseUrl, instance = _a.instance;
        if (params === void 0) { params = {}; }
        var _this = _super.call(this, params) || this;
        _this.instance = instance;
        _this.baseUrl = baseUrl;
        if (params.nestedUrl)
            _this.nestedUrl = params.nestedUrl;
        return _this;
    }
    EndpointCreatorApiConsumer.prototype.createItem = function (_a) {
        var itemInstance = _a.itemInstance;
        var itemCopy = dcopy(itemInstance);
        if (this.preRequestHandler) {
            itemCopy = this.preRequestHandler(itemCopy);
        }
        if (this.fieldsToSend) {
            itemCopy = sanitizer(itemCopy, this.fieldsToSend);
        }
        return this._createItem(itemCopy);
    };
    EndpointCreatorApiConsumer.prototype.createNestedItem = function (_a) {
        var parentId = _a.parentId, itemInstance = _a.itemInstance;
        var itemCopy = dcopy(itemInstance);
        if (this.preRequestHandler) {
            itemCopy = this.preRequestHandler(itemCopy);
        }
        if (this.fieldsToSend) {
            itemCopy = sanitizer(itemCopy, this.fieldsToSend);
        }
        var baseUrl = this.baseUrl + "/" + parentId + "/" + this.nestedUrl;
        return this._createItem(itemCopy, baseUrl);
    };
    EndpointCreatorApiConsumer.prototype._createItem = function (item, baseUrl) {
        if (baseUrl === void 0) { baseUrl = this.baseUrl; }
        return __awaiter(this, void 0, void 0, function () {
            var response, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.instance.post(baseUrl, item)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, this.responseHandler(response)];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return EndpointCreatorApiConsumer;
}(BaseCreatorApiConsumer));
export default EndpointCreatorApiConsumer;
//# sourceMappingURL=endpoint-creator-api-consumer.js.map