// tslint:disable
/**
 * Webitel engine API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 20.12.0
 * Contact: support@webitel.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { __assign, __awaiter, __extends, __generator } from "tslib";
import * as globalImportUrl from 'url';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, BaseAPI, RequiredError, } from '../base';
/**
 * AgentServiceApi - axios parameter creator
 * @export
 */
export var AgentServiceApiAxiosParamCreator = function (configuration) {
    var _this = this;
    return {
        /**
         *
         * @param {number} agentId
         * @param {EngineAgentSetStateRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        agentSetState: function (agentId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'agentId' is not null or undefined
                            if (agentId === null || agentId === undefined) {
                                throw new RequiredError('agentId', 'Required parameter agentId was null or undefined when calling agentSetState.');
                            }
                            // verify required parameter 'body' is not null or undefined
                            if (body === null || body === undefined) {
                                throw new RequiredError('body', 'Required parameter body was null or undefined when calling agentSetState.');
                            }
                            localVarPath = "/call_center/agents/{agent_id}/states/waiting".replace("{" + 'agent_id' + "}", encodeURIComponent(String(agentId)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'PATCH' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            localVarHeaderParameter['Content-Type'] = 'application/json';
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            needsSerialization = typeof body !== 'string' ||
                                localVarRequestOptions.headers['Content-Type'] === 'application/json';
                            localVarRequestOptions.data = needsSerialization
                                ? JSON.stringify(body !== undefined ? body : {})
                                : body || '';
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        agentStateHistory: function (agentId, page, size, timeFrom, timeTo, q, domainId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'agentId' is not null or undefined
                            if (agentId === null || agentId === undefined) {
                                throw new RequiredError('agentId', 'Required parameter agentId was null or undefined when calling agentStateHistory.');
                            }
                            localVarPath = "/call_center/agents/{agent_id}/states/history".replace("{" + 'agent_id' + "}", encodeURIComponent(String(agentId)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (timeFrom !== undefined) {
                                localVarQueryParameter['time_from'] = timeFrom;
                            }
                            if (timeTo !== undefined) {
                                localVarQueryParameter['time_to'] = timeTo;
                            }
                            if (q !== undefined) {
                                localVarQueryParameter['q'] = q;
                            }
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create Agent
         * @param {EngineCreateAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createAgent: function (body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'body' is not null or undefined
                            if (body === null || body === undefined) {
                                throw new RequiredError('body', 'Required parameter body was null or undefined when calling createAgent.');
                            }
                            localVarPath = "/call_center/agents";
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            localVarHeaderParameter['Content-Type'] = 'application/json';
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            needsSerialization = typeof body !== 'string' ||
                                localVarRequestOptions.headers['Content-Type'] === 'application/json';
                            localVarRequestOptions.data = needsSerialization
                                ? JSON.stringify(body !== undefined ? body : {})
                                : body || '';
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Remove Agent
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteAgent: function (id, domainId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'id' is not null or undefined
                            if (id === null || id === undefined) {
                                throw new RequiredError('id', 'Required parameter id was null or undefined when calling deleteAgent.');
                            }
                            localVarPath = "/call_center/agents/{id}".replace("{" + 'id' + "}", encodeURIComponent(String(id)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Update Agent
         * @param {string} id
         * @param {EnginePatchAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchAgent: function (id, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'id' is not null or undefined
                            if (id === null || id === undefined) {
                                throw new RequiredError('id', 'Required parameter id was null or undefined when calling patchAgent.');
                            }
                            // verify required parameter 'body' is not null or undefined
                            if (body === null || body === undefined) {
                                throw new RequiredError('body', 'Required parameter body was null or undefined when calling patchAgent.');
                            }
                            localVarPath = "/call_center/agents/{id}".replace("{" + 'id' + "}", encodeURIComponent(String(id)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'PATCH' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            localVarHeaderParameter['Content-Type'] = 'application/json';
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            needsSerialization = typeof body !== 'string' ||
                                localVarRequestOptions.headers['Content-Type'] === 'application/json';
                            localVarRequestOptions.data = needsSerialization
                                ? JSON.stringify(body !== undefined ? body : {})
                                : body || '';
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Agent item
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        readAgent: function (id, domainId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'id' is not null or undefined
                            if (id === null || id === undefined) {
                                throw new RequiredError('id', 'Required parameter id was null or undefined when calling readAgent.');
                            }
                            localVarPath = "/call_center/agents/{id}".replace("{" + 'id' + "}", encodeURIComponent(String(id)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary List of Agent
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<string>} [id]
         * @param {Array<string>} [allowChannels]
         * @param {Array<number>} [supervisorId]
         * @param {Array<number>} [teamId]
         * @param {Array<number>} [regionId]
         * @param {Array<number>} [auditorId]
         * @param {boolean} [isSupervisor]
         * @param {Array<number>} [skillId]
         * @param {Array<number>} [queueId]
         * @param {boolean} [notSupervisor]
         * @param {Array<string>} [userId]
         * @param {Array<string>} [extension]
         * @param {Array<number>} [notTeamId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgent: function (page, size, q, sort, fields, id, allowChannels, supervisorId, teamId, regionId, auditorId, isSupervisor, skillId, queueId, notSupervisor, userId, extension, notTeamId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            localVarPath = "/call_center/agents";
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (q !== undefined) {
                                localVarQueryParameter['q'] = q;
                            }
                            if (sort !== undefined) {
                                localVarQueryParameter['sort'] = sort;
                            }
                            if (fields) {
                                localVarQueryParameter['fields'] = fields;
                            }
                            if (id) {
                                localVarQueryParameter['id'] = id;
                            }
                            if (allowChannels) {
                                localVarQueryParameter['allow_channels'] = allowChannels;
                            }
                            if (supervisorId) {
                                localVarQueryParameter['supervisor_id'] = supervisorId;
                            }
                            if (teamId) {
                                localVarQueryParameter['team_id'] = teamId;
                            }
                            if (regionId) {
                                localVarQueryParameter['region_id'] = regionId;
                            }
                            if (auditorId) {
                                localVarQueryParameter['auditor_id'] = auditorId;
                            }
                            if (isSupervisor !== undefined) {
                                localVarQueryParameter['is_supervisor'] = isSupervisor;
                            }
                            if (skillId) {
                                localVarQueryParameter['skill_id'] = skillId;
                            }
                            if (queueId) {
                                localVarQueryParameter['queue_id'] = queueId;
                            }
                            if (notSupervisor !== undefined) {
                                localVarQueryParameter['not_supervisor'] = notSupervisor;
                            }
                            if (userId) {
                                localVarQueryParameter['user_id'] = userId;
                            }
                            if (extension) {
                                localVarQueryParameter['extension'] = extension;
                            }
                            if (notTeamId) {
                                localVarQueryParameter['not_team_id'] = notTeamId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {Array<number>} [agentId]
         * @param {string} [domainId]
         * @param {string} [q]
         * @param {Array<string>} [fields]
         * @param {string} [sort]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentCallStatistics: function (page, size, timeFrom, timeTo, agentId, domainId, q, fields, sort, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            localVarPath = "/call_center/agents/reports/call";
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (timeFrom !== undefined) {
                                localVarQueryParameter['time.from'] = timeFrom;
                            }
                            if (timeTo !== undefined) {
                                localVarQueryParameter['time.to'] = timeTo;
                            }
                            if (agentId) {
                                localVarQueryParameter['agent_id'] = agentId;
                            }
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            if (q !== undefined) {
                                localVarQueryParameter['q'] = q;
                            }
                            if (fields) {
                                localVarQueryParameter['fields'] = fields;
                            }
                            if (sort !== undefined) {
                                localVarQueryParameter['sort'] = sort;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} id
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInQueue: function (id, page, size, q, sort, fields, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'id' is not null or undefined
                            if (id === null || id === undefined) {
                                throw new RequiredError('id', 'Required parameter id was null or undefined when calling searchAgentInQueue.');
                            }
                            localVarPath = "/call_center/agents/{id}/queues".replace("{" + 'id' + "}", encodeURIComponent(String(id)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (q !== undefined) {
                                localVarQueryParameter['q'] = q;
                            }
                            if (sort !== undefined) {
                                localVarQueryParameter['sort'] = sort;
                            }
                            if (fields) {
                                localVarQueryParameter['fields'] = fields;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInQueueStatistics: function (agentId, domainId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'agentId' is not null or undefined
                            if (agentId === null || agentId === undefined) {
                                throw new RequiredError('agentId', 'Required parameter agentId was null or undefined when calling searchAgentInQueueStatistics.');
                            }
                            localVarPath = "/call_center/agents/{agent_id}/statistics/queues".replace("{" + 'agent_id' + "}", encodeURIComponent(String(agentId)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary todo deprecated ?
         * @param {string} id
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInTeam: function (id, page, size, q, domainId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'id' is not null or undefined
                            if (id === null || id === undefined) {
                                throw new RequiredError('id', 'Required parameter id was null or undefined when calling searchAgentInTeam.');
                            }
                            localVarPath = "/call_center/agents/{id}/teams".replace("{" + 'id' + "}", encodeURIComponent(String(id)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (q !== undefined) {
                                localVarQueryParameter['q'] = q;
                            }
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [joinedAtFrom]
         * @param {string} [joinedAtTo]
         * @param {Array<string>} [agentId]
         * @param {string} [sort]
         * @param {string} [domainId]
         * @param {string} [fromId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStateHistory: function (page, size, joinedAtFrom, joinedAtTo, agentId, sort, domainId, fromId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            localVarPath = "/call_center/agents/states/history";
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (joinedAtFrom !== undefined) {
                                localVarQueryParameter['joined_at.from'] = joinedAtFrom;
                            }
                            if (joinedAtTo !== undefined) {
                                localVarQueryParameter['joined_at.to'] = joinedAtTo;
                            }
                            if (agentId) {
                                localVarQueryParameter['agent_id'] = agentId;
                            }
                            if (sort !== undefined) {
                                localVarQueryParameter['sort'] = sort;
                            }
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            if (fromId !== undefined) {
                                localVarQueryParameter['from_id'] = fromId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<string>} [agentId]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {Array<string>} [status]
         * @param {Array<number>} [queueId]
         * @param {Array<number>} [teamId]
         * @param {string} [utilizationFrom]
         * @param {string} [utilizationTo]
         * @param {boolean} [hasCall]
         * @param {Array<number>} [skillId]
         * @param {Array<number>} [regionId]
         * @param {Array<number>} [supervisorId]
         * @param {Array<string>} [auditorId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStatusStatistic: function (page, size, q, sort, fields, agentId, timeFrom, timeTo, status, queueId, teamId, utilizationFrom, utilizationTo, hasCall, skillId, regionId, supervisorId, auditorId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            localVarPath = "/call_center/agents/reports/status";
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (q !== undefined) {
                                localVarQueryParameter['q'] = q;
                            }
                            if (sort !== undefined) {
                                localVarQueryParameter['sort'] = sort;
                            }
                            if (fields) {
                                localVarQueryParameter['fields'] = fields;
                            }
                            if (agentId) {
                                localVarQueryParameter['agent_id'] = agentId;
                            }
                            if (timeFrom !== undefined) {
                                localVarQueryParameter['time.from'] = timeFrom;
                            }
                            if (timeTo !== undefined) {
                                localVarQueryParameter['time.to'] = timeTo;
                            }
                            if (status) {
                                localVarQueryParameter['status'] = status;
                            }
                            if (queueId) {
                                localVarQueryParameter['queue_id'] = queueId;
                            }
                            if (teamId) {
                                localVarQueryParameter['team_id'] = teamId;
                            }
                            if (utilizationFrom !== undefined) {
                                localVarQueryParameter['utilization.from'] = utilizationFrom;
                            }
                            if (utilizationTo !== undefined) {
                                localVarQueryParameter['utilization.to'] = utilizationTo;
                            }
                            if (hasCall !== undefined) {
                                localVarQueryParameter['has_call'] = hasCall;
                            }
                            if (skillId) {
                                localVarQueryParameter['skill_id'] = skillId;
                            }
                            if (regionId) {
                                localVarQueryParameter['region_id'] = regionId;
                            }
                            if (supervisorId) {
                                localVarQueryParameter['supervisor_id'] = supervisorId;
                            }
                            if (auditorId) {
                                localVarQueryParameter['auditor_id'] = auditorId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStatusStatisticItem: function (agentId, timeFrom, timeTo, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'agentId' is not null or undefined
                            if (agentId === null || agentId === undefined) {
                                throw new RequiredError('agentId', 'Required parameter agentId was null or undefined when calling searchAgentStatusStatisticItem.');
                            }
                            localVarPath = "/call_center/agents/reports/status/{agent_id}".replace("{" + 'agent_id' + "}", encodeURIComponent(String(agentId)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (timeFrom !== undefined) {
                                localVarQueryParameter['time.from'] = timeFrom;
                            }
                            if (timeTo !== undefined) {
                                localVarQueryParameter['time.to'] = timeTo;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary SearchLookupAgentNotExistsUser
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchLookupUsersAgentNotExists: function (page, size, q, domainId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            localVarPath = "/call_center/lookups/agents/users";
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (page !== undefined) {
                                localVarQueryParameter['page'] = page;
                            }
                            if (size !== undefined) {
                                localVarQueryParameter['size'] = size;
                            }
                            if (q !== undefined) {
                                localVarQueryParameter['q'] = q;
                            }
                            if (domainId !== undefined) {
                                localVarQueryParameter['domain_id'] = domainId;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {boolean} [allowChange]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchPauseCauseForAgent: function (agentId, allowChange, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'agentId' is not null or undefined
                            if (agentId === null || agentId === undefined) {
                                throw new RequiredError('agentId', 'Required parameter agentId was null or undefined when calling searchPauseCauseForAgent.');
                            }
                            localVarPath = "/call_center/agents/{agent_id}/pause_causes".replace("{" + 'agent_id' + "}", encodeURIComponent(String(agentId)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            if (allowChange !== undefined) {
                                localVarQueryParameter['allow_change'] = allowChange;
                            }
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Update Agent
         * @param {string} id
         * @param {EngineUpdateAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAgent: function (id, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'id' is not null or undefined
                            if (id === null || id === undefined) {
                                throw new RequiredError('id', 'Required parameter id was null or undefined when calling updateAgent.');
                            }
                            // verify required parameter 'body' is not null or undefined
                            if (body === null || body === undefined) {
                                throw new RequiredError('body', 'Required parameter body was null or undefined when calling updateAgent.');
                            }
                            localVarPath = "/call_center/agents/{id}".replace("{" + 'id' + "}", encodeURIComponent(String(id)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'PUT' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            localVarHeaderParameter['Content-Type'] = 'application/json';
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            needsSerialization = typeof body !== 'string' ||
                                localVarRequestOptions.headers['Content-Type'] === 'application/json';
                            localVarRequestOptions.data = needsSerialization
                                ? JSON.stringify(body !== undefined ? body : {})
                                : body || '';
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Change agent status
         * @param {string} id
         * @param {EngineAgentStatusRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAgentStatus: function (id, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarApiKeyValue, _a, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // verify required parameter 'id' is not null or undefined
                            if (id === null || id === undefined) {
                                throw new RequiredError('id', 'Required parameter id was null or undefined when calling updateAgentStatus.');
                            }
                            // verify required parameter 'body' is not null or undefined
                            if (body === null || body === undefined) {
                                throw new RequiredError('body', 'Required parameter body was null or undefined when calling updateAgentStatus.');
                            }
                            localVarPath = "/call_center/agents/{id}/status".replace("{" + 'id' + "}", encodeURIComponent(String(id)));
                            localVarUrlObj = globalImportUrl.parse(localVarPath, true);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'PATCH' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                            if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                            return [4 /*yield*/, configuration.apiKey('X-Webitel-Access')];
                        case 1:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, configuration.apiKey];
                        case 3:
                            _a = _b.sent();
                            _b.label = 4;
                        case 4:
                            localVarApiKeyValue = _a;
                            localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
                            _b.label = 5;
                        case 5:
                            localVarHeaderParameter['Content-Type'] = 'application/json';
                            localVarUrlObj.query = __assign(__assign(__assign({}, localVarUrlObj.query), localVarQueryParameter), options.query);
                            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
                            delete localVarUrlObj.search;
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            needsSerialization = typeof body !== 'string' ||
                                localVarRequestOptions.headers['Content-Type'] === 'application/json';
                            localVarRequestOptions.data = needsSerialization
                                ? JSON.stringify(body !== undefined ? body : {})
                                : body || '';
                            return [2 /*return*/, {
                                    url: globalImportUrl.format(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
    };
};
/**
 * AgentServiceApi - functional programming interface
 * @export
 */
export var AgentServiceApiFp = function (configuration) {
    return {
        /**
         *
         * @param {number} agentId
         * @param {EngineAgentSetStateRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        agentSetState: function (agentId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).agentSetState(agentId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        agentStateHistory: function (agentId, page, size, timeFrom, timeTo, q, domainId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).agentStateHistory(agentId, page, size, timeFrom, timeTo, q, domainId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create Agent
         * @param {EngineCreateAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createAgent: function (body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).createAgent(body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Remove Agent
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteAgent: function (id, domainId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).deleteAgent(id, domainId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Update Agent
         * @param {string} id
         * @param {EnginePatchAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchAgent: function (id, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).patchAgent(id, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Agent item
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        readAgent: function (id, domainId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).readAgent(id, domainId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary List of Agent
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<string>} [id]
         * @param {Array<string>} [allowChannels]
         * @param {Array<number>} [supervisorId]
         * @param {Array<number>} [teamId]
         * @param {Array<number>} [regionId]
         * @param {Array<number>} [auditorId]
         * @param {boolean} [isSupervisor]
         * @param {Array<number>} [skillId]
         * @param {Array<number>} [queueId]
         * @param {boolean} [notSupervisor]
         * @param {Array<string>} [userId]
         * @param {Array<string>} [extension]
         * @param {Array<number>} [notTeamId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgent: function (page, size, q, sort, fields, id, allowChannels, supervisorId, teamId, regionId, auditorId, isSupervisor, skillId, queueId, notSupervisor, userId, extension, notTeamId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgent(page, size, q, sort, fields, id, allowChannels, supervisorId, teamId, regionId, auditorId, isSupervisor, skillId, queueId, notSupervisor, userId, extension, notTeamId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {Array<number>} [agentId]
         * @param {string} [domainId]
         * @param {string} [q]
         * @param {Array<string>} [fields]
         * @param {string} [sort]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentCallStatistics: function (page, size, timeFrom, timeTo, agentId, domainId, q, fields, sort, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgentCallStatistics(page, size, timeFrom, timeTo, agentId, domainId, q, fields, sort, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} id
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInQueue: function (id, page, size, q, sort, fields, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgentInQueue(id, page, size, q, sort, fields, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInQueueStatistics: function (agentId, domainId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgentInQueueStatistics(agentId, domainId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary todo deprecated ?
         * @param {string} id
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInTeam: function (id, page, size, q, domainId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgentInTeam(id, page, size, q, domainId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [joinedAtFrom]
         * @param {string} [joinedAtTo]
         * @param {Array<string>} [agentId]
         * @param {string} [sort]
         * @param {string} [domainId]
         * @param {string} [fromId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStateHistory: function (page, size, joinedAtFrom, joinedAtTo, agentId, sort, domainId, fromId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgentStateHistory(page, size, joinedAtFrom, joinedAtTo, agentId, sort, domainId, fromId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<string>} [agentId]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {Array<string>} [status]
         * @param {Array<number>} [queueId]
         * @param {Array<number>} [teamId]
         * @param {string} [utilizationFrom]
         * @param {string} [utilizationTo]
         * @param {boolean} [hasCall]
         * @param {Array<number>} [skillId]
         * @param {Array<number>} [regionId]
         * @param {Array<number>} [supervisorId]
         * @param {Array<string>} [auditorId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStatusStatistic: function (page, size, q, sort, fields, agentId, timeFrom, timeTo, status, queueId, teamId, utilizationFrom, utilizationTo, hasCall, skillId, regionId, supervisorId, auditorId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgentStatusStatistic(page, size, q, sort, fields, agentId, timeFrom, timeTo, status, queueId, teamId, utilizationFrom, utilizationTo, hasCall, skillId, regionId, supervisorId, auditorId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStatusStatisticItem: function (agentId, timeFrom, timeTo, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchAgentStatusStatisticItem(agentId, timeFrom, timeTo, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary SearchLookupAgentNotExistsUser
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchLookupUsersAgentNotExists: function (page, size, q, domainId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchLookupUsersAgentNotExists(page, size, q, domainId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {string} agentId
         * @param {boolean} [allowChange]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchPauseCauseForAgent: function (agentId, allowChange, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).searchPauseCauseForAgent(agentId, allowChange, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Update Agent
         * @param {string} id
         * @param {EngineUpdateAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAgent: function (id, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).updateAgent(id, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Change agent status
         * @param {string} id
         * @param {EngineAgentStatusRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAgentStatus: function (id, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AgentServiceApiAxiosParamCreator(configuration).updateAgentStatus(id, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = globalAxios; }
                                    if (basePath === void 0) { basePath = BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
    };
};
/**
 * AgentServiceApi - factory interface
 * @export
 */
export var AgentServiceApiFactory = function (configuration, basePath, axios) {
    return {
        /**
         *
         * @param {number} agentId
         * @param {EngineAgentSetStateRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        agentSetState: function (agentId, body, options) {
            return AgentServiceApiFp(configuration)
                .agentSetState(agentId, body, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {string} agentId
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        agentStateHistory: function (agentId, page, size, timeFrom, timeTo, q, domainId, options) {
            return AgentServiceApiFp(configuration)
                .agentStateHistory(agentId, page, size, timeFrom, timeTo, q, domainId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary Create Agent
         * @param {EngineCreateAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createAgent: function (body, options) {
            return AgentServiceApiFp(configuration)
                .createAgent(body, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary Remove Agent
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteAgent: function (id, domainId, options) {
            return AgentServiceApiFp(configuration)
                .deleteAgent(id, domainId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary Update Agent
         * @param {string} id
         * @param {EnginePatchAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchAgent: function (id, body, options) {
            return AgentServiceApiFp(configuration)
                .patchAgent(id, body, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary Agent item
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        readAgent: function (id, domainId, options) {
            return AgentServiceApiFp(configuration)
                .readAgent(id, domainId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary List of Agent
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<string>} [id]
         * @param {Array<string>} [allowChannels]
         * @param {Array<number>} [supervisorId]
         * @param {Array<number>} [teamId]
         * @param {Array<number>} [regionId]
         * @param {Array<number>} [auditorId]
         * @param {boolean} [isSupervisor]
         * @param {Array<number>} [skillId]
         * @param {Array<number>} [queueId]
         * @param {boolean} [notSupervisor]
         * @param {Array<string>} [userId]
         * @param {Array<string>} [extension]
         * @param {Array<number>} [notTeamId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgent: function (page, size, q, sort, fields, id, allowChannels, supervisorId, teamId, regionId, auditorId, isSupervisor, skillId, queueId, notSupervisor, userId, extension, notTeamId, options) {
            return AgentServiceApiFp(configuration)
                .searchAgent(page, size, q, sort, fields, id, allowChannels, supervisorId, teamId, regionId, auditorId, isSupervisor, skillId, queueId, notSupervisor, userId, extension, notTeamId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {Array<number>} [agentId]
         * @param {string} [domainId]
         * @param {string} [q]
         * @param {Array<string>} [fields]
         * @param {string} [sort]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentCallStatistics: function (page, size, timeFrom, timeTo, agentId, domainId, q, fields, sort, options) {
            return AgentServiceApiFp(configuration)
                .searchAgentCallStatistics(page, size, timeFrom, timeTo, agentId, domainId, q, fields, sort, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {string} id
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInQueue: function (id, page, size, q, sort, fields, options) {
            return AgentServiceApiFp(configuration)
                .searchAgentInQueue(id, page, size, q, sort, fields, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {string} agentId
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInQueueStatistics: function (agentId, domainId, options) {
            return AgentServiceApiFp(configuration)
                .searchAgentInQueueStatistics(agentId, domainId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary todo deprecated ?
         * @param {string} id
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentInTeam: function (id, page, size, q, domainId, options) {
            return AgentServiceApiFp(configuration)
                .searchAgentInTeam(id, page, size, q, domainId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [joinedAtFrom]
         * @param {string} [joinedAtTo]
         * @param {Array<string>} [agentId]
         * @param {string} [sort]
         * @param {string} [domainId]
         * @param {string} [fromId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStateHistory: function (page, size, joinedAtFrom, joinedAtTo, agentId, sort, domainId, fromId, options) {
            return AgentServiceApiFp(configuration)
                .searchAgentStateHistory(page, size, joinedAtFrom, joinedAtTo, agentId, sort, domainId, fromId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<string>} [agentId]
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {Array<string>} [status]
         * @param {Array<number>} [queueId]
         * @param {Array<number>} [teamId]
         * @param {string} [utilizationFrom]
         * @param {string} [utilizationTo]
         * @param {boolean} [hasCall]
         * @param {Array<number>} [skillId]
         * @param {Array<number>} [regionId]
         * @param {Array<number>} [supervisorId]
         * @param {Array<string>} [auditorId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStatusStatistic: function (page, size, q, sort, fields, agentId, timeFrom, timeTo, status, queueId, teamId, utilizationFrom, utilizationTo, hasCall, skillId, regionId, supervisorId, auditorId, options) {
            return AgentServiceApiFp(configuration)
                .searchAgentStatusStatistic(page, size, q, sort, fields, agentId, timeFrom, timeTo, status, queueId, teamId, utilizationFrom, utilizationTo, hasCall, skillId, regionId, supervisorId, auditorId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {string} agentId
         * @param {string} [timeFrom]
         * @param {string} [timeTo]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAgentStatusStatisticItem: function (agentId, timeFrom, timeTo, options) {
            return AgentServiceApiFp(configuration)
                .searchAgentStatusStatisticItem(agentId, timeFrom, timeTo, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary SearchLookupAgentNotExistsUser
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchLookupUsersAgentNotExists: function (page, size, q, domainId, options) {
            return AgentServiceApiFp(configuration)
                .searchLookupUsersAgentNotExists(page, size, q, domainId, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {string} agentId
         * @param {boolean} [allowChange]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchPauseCauseForAgent: function (agentId, allowChange, options) {
            return AgentServiceApiFp(configuration)
                .searchPauseCauseForAgent(agentId, allowChange, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary Update Agent
         * @param {string} id
         * @param {EngineUpdateAgentRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAgent: function (id, body, options) {
            return AgentServiceApiFp(configuration)
                .updateAgent(id, body, options)
                .then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @summary Change agent status
         * @param {string} id
         * @param {EngineAgentStatusRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAgentStatus: function (id, body, options) {
            return AgentServiceApiFp(configuration)
                .updateAgentStatus(id, body, options)
                .then(function (request) { return request(axios, basePath); });
        },
    };
};
/**
 * AgentServiceApi - object-oriented interface
 * @export
 * @class AgentServiceApi
 * @extends {BaseAPI}
 */
var AgentServiceApi = /** @class */ (function (_super) {
    __extends(AgentServiceApi, _super);
    function AgentServiceApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     *
     * @param {number} agentId
     * @param {EngineAgentSetStateRequest} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.agentSetState = function (agentId, body, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .agentSetState(agentId, body, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {string} agentId
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [timeFrom]
     * @param {string} [timeTo]
     * @param {string} [q]
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.agentStateHistory = function (agentId, page, size, timeFrom, timeTo, q, domainId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .agentStateHistory(agentId, page, size, timeFrom, timeTo, q, domainId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary Create Agent
     * @param {EngineCreateAgentRequest} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.createAgent = function (body, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .createAgent(body, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary Remove Agent
     * @param {string} id
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.deleteAgent = function (id, domainId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .deleteAgent(id, domainId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary Update Agent
     * @param {string} id
     * @param {EnginePatchAgentRequest} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.patchAgent = function (id, body, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .patchAgent(id, body, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary Agent item
     * @param {string} id
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.readAgent = function (id, domainId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .readAgent(id, domainId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary List of Agent
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [q]
     * @param {string} [sort]
     * @param {Array<string>} [fields]
     * @param {Array<string>} [id]
     * @param {Array<string>} [allowChannels]
     * @param {Array<number>} [supervisorId]
     * @param {Array<number>} [teamId]
     * @param {Array<number>} [regionId]
     * @param {Array<number>} [auditorId]
     * @param {boolean} [isSupervisor]
     * @param {Array<number>} [skillId]
     * @param {Array<number>} [queueId]
     * @param {boolean} [notSupervisor]
     * @param {Array<string>} [userId]
     * @param {Array<string>} [extension]
     * @param {Array<number>} [notTeamId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgent = function (page, size, q, sort, fields, id, allowChannels, supervisorId, teamId, regionId, auditorId, isSupervisor, skillId, queueId, notSupervisor, userId, extension, notTeamId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgent(page, size, q, sort, fields, id, allowChannels, supervisorId, teamId, regionId, auditorId, isSupervisor, skillId, queueId, notSupervisor, userId, extension, notTeamId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [timeFrom]
     * @param {string} [timeTo]
     * @param {Array<number>} [agentId]
     * @param {string} [domainId]
     * @param {string} [q]
     * @param {Array<string>} [fields]
     * @param {string} [sort]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgentCallStatistics = function (page, size, timeFrom, timeTo, agentId, domainId, q, fields, sort, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgentCallStatistics(page, size, timeFrom, timeTo, agentId, domainId, q, fields, sort, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {string} id
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [q]
     * @param {string} [sort]
     * @param {Array<string>} [fields]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgentInQueue = function (id, page, size, q, sort, fields, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgentInQueue(id, page, size, q, sort, fields, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {string} agentId
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgentInQueueStatistics = function (agentId, domainId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgentInQueueStatistics(agentId, domainId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary todo deprecated ?
     * @param {string} id
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [q]
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgentInTeam = function (id, page, size, q, domainId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgentInTeam(id, page, size, q, domainId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [joinedAtFrom]
     * @param {string} [joinedAtTo]
     * @param {Array<string>} [agentId]
     * @param {string} [sort]
     * @param {string} [domainId]
     * @param {string} [fromId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgentStateHistory = function (page, size, joinedAtFrom, joinedAtTo, agentId, sort, domainId, fromId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgentStateHistory(page, size, joinedAtFrom, joinedAtTo, agentId, sort, domainId, fromId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [q]
     * @param {string} [sort]
     * @param {Array<string>} [fields]
     * @param {Array<string>} [agentId]
     * @param {string} [timeFrom]
     * @param {string} [timeTo]
     * @param {Array<string>} [status]
     * @param {Array<number>} [queueId]
     * @param {Array<number>} [teamId]
     * @param {string} [utilizationFrom]
     * @param {string} [utilizationTo]
     * @param {boolean} [hasCall]
     * @param {Array<number>} [skillId]
     * @param {Array<number>} [regionId]
     * @param {Array<number>} [supervisorId]
     * @param {Array<string>} [auditorId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgentStatusStatistic = function (page, size, q, sort, fields, agentId, timeFrom, timeTo, status, queueId, teamId, utilizationFrom, utilizationTo, hasCall, skillId, regionId, supervisorId, auditorId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgentStatusStatistic(page, size, q, sort, fields, agentId, timeFrom, timeTo, status, queueId, teamId, utilizationFrom, utilizationTo, hasCall, skillId, regionId, supervisorId, auditorId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {string} agentId
     * @param {string} [timeFrom]
     * @param {string} [timeTo]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchAgentStatusStatisticItem = function (agentId, timeFrom, timeTo, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchAgentStatusStatisticItem(agentId, timeFrom, timeTo, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary SearchLookupAgentNotExistsUser
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [q]
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchLookupUsersAgentNotExists = function (page, size, q, domainId, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchLookupUsersAgentNotExists(page, size, q, domainId, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {string} agentId
     * @param {boolean} [allowChange]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.searchPauseCauseForAgent = function (agentId, allowChange, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .searchPauseCauseForAgent(agentId, allowChange, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary Update Agent
     * @param {string} id
     * @param {EngineUpdateAgentRequest} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.updateAgent = function (id, body, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .updateAgent(id, body, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @summary Change agent status
     * @param {string} id
     * @param {EngineAgentStatusRequest} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AgentServiceApi
     */
    AgentServiceApi.prototype.updateAgentStatus = function (id, body, options) {
        var _this = this;
        return AgentServiceApiFp(this.configuration)
            .updateAgentStatus(id, body, options)
            .then(function (request) { return request(_this.axios, _this.basePath); });
    };
    return AgentServiceApi;
}(BaseAPI));
export { AgentServiceApi };
//# sourceMappingURL=agent-service-api.js.map